#ifndef CLUSTERING_H
#define CLUSTERING_H


class Clustering;
#include "mypdbreader/reader.h"
#include "ensemble_cluster.h"
#include <string>


class Clustering
{
    reader *info;
    Ensemble_Cluster *mes_cluster_tab;
    int cutoffPoint;
    double **matriceRMSD;

public:
    Clustering(reader * info,bool debug = false);
    ~Clustering();

    double getRMSD(int x,int y);
    int getCutoffPoint();

    void calculerRMSD();

    static reader * getReaderfromPdbFile(std::string chemin);


    void printResultText();
    void printResultText(std::string fichier);
    void printResultTab();
    void printResultTab(std::string fichier);


};

#endif // CLUSTERING_H
