#include <iostream>
#include <cstring>
#include <cstdio>
#include "atom.h"



Atom::Atom()
{
    this->hetatm = false;
    element[0] = ' ';
    element[1] = ' ';
    element[2] = ' ';
}
Atom::Atom(Point coord)
{
    this->hetatm = false;
    this->x = coord.x;
    this->y = coord.y;
    this->z = coord.z;
}
Atom::Atom(bool hetatm,int snum,char name[5],char alt,char resname[4],char chain,int resnum,char insertion_residue_code,Point coord,
float occupancy,float tempFactor,char segID[5],char element[3],char charge[3])
{
    this->hetatm = hetatm;
    this->snum = snum;
    strcpy(this->name, name);
    this->alt = alt;
    strcpy(this->resname,resname);
    this->chain = chain;
    this->resnum = resnum;
    this->insertion_residue_code = insertion_residue_code;
    this->x = coord.x;
    this->y = coord.y;
    this->z = coord.z;
    this->occupancy = occupancy;
    this->tempFactor = tempFactor;
    strcpy(this->segID ,segID);
    strcpy(this->element,element);
    strcpy(this->charge,charge);

}
void Atom::set_cartesian_coords(Point coord)
{
    this->x = coord.x;
    this->y = coord.y;
    this->z = coord.z;
}

Point Atom::getCartesianCoord()
{
    return Point(this->x,this->y,this->z);
}
char Atom::type()
{
    if(element[0] != ' ')
    {
        return element[0];
    }
    else if(element[1] != ' ')
    {
        return element[1];
    }
    else
    {
        return element[2];
    }
}
int Atom::getIndex()
{
    return this->resnum;
}

char Atom::getchain()
{
    return this->chain;
}

char* Atom::getresname()
{
    return this->resname;
}

void Atom::write(std::ostream &out)
{
    char line[81];

    static const char atom_line_oformat_[]="ATOM  %5d %4s%1c%3s %1c%4d%1c   %8.3f%8.3f%8.3f%6.2f%6.2f      %4s%2s%2s";
    static const char hetatm_line_oformat_[]="HETATM  %5d %4s%1c%3s %1c%4d%1c   %8.3f%8.3f%8.3f%6.2f%6.2f      %4s%2s%2s";

    if(this->hetatm)
    {
        sprintf(line, hetatm_line_oformat_,snum, name, alt,resname, chain, resnum, insertion_residue_code,
        x, y, z, occupancy, tempFactor, segID,element, charge);
    }
    else
    {
        sprintf(line, atom_line_oformat_,snum, name, alt,resname, chain, resnum, insertion_residue_code,
        x, y, z, occupancy, tempFactor, segID,element, charge);
    }
    out << line << std::endl;

}
