#ifndef ATOM_H
#define ATOM_H



struct Point
{
    float x,y,z;
    Point(float x,float y,float z)
    {
        this->x = x;
        this->y = y;
        this->z = z;
    }
};

class Atom
{
    bool hetatm;
    int snum;
    char name[5];
    char alt;
    char resname[4];
    char chain;
    int resnum;
    char insertion_residue_code;
    float x,y,z;
    float occupancy, tempFactor;
    char segID[5];
    char element[3];
    char charge[3];
public:
    Atom();
    Atom(bool hetatm,int snum,char name[5],char alt,char resname[4],char chain,int resnum,char insertion_residue_code,Point coord,
    float occupancy,float tempFactor,char segID[5],char element[3],char charge[3]);
    Atom(Point coord);

    char type();
    void set_cartesian_coords(Point coord);
    Point getCartesianCoord();
    int getIndex();
    char getchain();
    char* getresname();
    void write(std::ostream &out);
};

#endif // ATOM_H
