#ifndef PDBREADER_H
#define PDBREADER_H
#include "entrypdb.h"

typedef enum Line_type {HEADER, DBREF, SEQRES, ATOM, HETATM, MASTER, ENDMDL, OTHER, TER, MODEL, END} Line_type;
const char atom_line_iformat_[]= "ATOM  %5d%*1c%4c%1c%3c%*c%1c%4d%1c%*1c%*1c%*1c%8f%8f%8f%6f%6f%*1c%*1c%*1c%*1c%*1c%*1c%4c%2c%2c";
const char hetatm_line_iformat_[]= "HETATM  %5d%*1c%4c%1c%3c%*c%1c%4d%1c%*1c%*1c%*1c%8f%8f%8f%6f%6f%*1c%*1c%*1c%*1c%*1c%*1c%4c%2c%2c";

Line_type typedeLigne (const char* line);

class reader
{
     std::vector <Entrypdb *> m_file;
     std::vector <Model> m_proteine;
public:
    reader();

    unsigned int getNbEntryPDB(); // une entrer pdb est cree quand un fichier pdb est donner en entrer
    unsigned int getNbProteine();

    Entrypdb& getentryPDBAt(unsigned int i);
    Model& getProteineAt(unsigned int i);

    void write(std::ostream &out);
    void readPDB(std::istream &in);
    void readdoubleTabinput(double *coord, int Nbentry);
};

#endif // PDBREADER_H
